import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

class Interface extends JFrame implements ActionListener
{
	ListaDeFiguras lista;

	JButton but,but2;
	JPanel painel;
	JPanel botoes;
	JLabel texto;
	Tela tela;
	
	public Interface()
	{
		super("P4");
	    but  = new JButton("Quadrado");
		but2 = new JButton("Crculo");
		// Adiciona um listener para eventos de boto (Action)
		but.addActionListener(this);
		but2.addActionListener(this);
		texto = new JLabel("Opo selecionada:");
		// Tenta ler a lista de figuras do disco
		lista = carregaLista("teste.dat");
		// Cria a tela
		tela = new Tela(300,300,lista);
		// Cria o painel de botes
		botoes = new JPanel();
		botoes.setLayout(new BoxLayout(botoes,BoxLayout.Y_AXIS));
		botoes.add(but);
		botoes.add(but2);
		// Cria o painel principal
    	painel = new JPanel();    	
	  	painel.setLayout(new BorderLayout(3,3));
    	painel.add(botoes,BorderLayout.WEST);
    	painel.add(tela,BorderLayout.CENTER);
    	painel.add(texto,BorderLayout.SOUTH);
  		// Adiciona ao JFrame
	    getContentPane().add(painel);
		addWindowListener(new WindowAdapter()
		  {
			public void windowClosing(WindowEvent e)
			{
				salvaLista("teste.dat");
        		System.exit(0);
			}
		  });
	}
	
	public void actionPerformed(ActionEvent e)
	{
		if(e.getActionCommand().equals("Quadrado"))
		{
			texto.setText("Inserindo um quadrado");
			tela.setOption(1);
		}
		else
		{
			texto.setText("Inserindo um crculo");
			tela.setOption(2);
		}
	}

	public ListaDeFiguras carregaLista(String nome)
	{
		ListaDeFiguras lista;
		try
		{
			FileInputStream fs = new FileInputStream(nome);
			ObjectInputStream os = new ObjectInputStream(fs);
			lista = (ListaDeFiguras) os.readObject();
			os.close();
		}
		catch (Exception e)
		{
			System.out.println("Problemas na leitura!");
			lista = new ListaDeFiguras(20);
		}
		return lista;
	}

	public void salvaLista(String nome)
	{
		try
		{
			FileOutputStream fs = new FileOutputStream(nome);
			ObjectOutputStream os = new ObjectOutputStream(fs);
			os.writeObject(lista);
			os.close();
		}
		catch (Exception e)
		{
			System.out.println("Problemas na gravao!");
		}
	}

	public static void main(String args[])
	{
		Interface frame = new Interface();
		frame.pack();
		frame.show();
	}
}